/// <reference types="react" />
import * as React from "react";
import { IDataBinder } from "../../form/formCore";
import { FormBinderBase } from "../../form/formBinders";
export interface ITimeInputProps extends React.Props<TimeInput> {
    /** ((string) => void) Returns the time value when changed */
    onChange?: (time: string) => void;
    /** (string) The time value in HH:mm format */
    time?: string;
    /** (boolean) Should the picker disallow user interaction */
    disabled?: boolean;
}
export interface ITimerInputState {
    hours?: number;
    minutes?: number;
}
export declare class TimeInput extends React.Component<ITimeInputProps, ITimerInputState> {
    constructor();
    componentWillMount(): void;
    hourChanged(hour: string): void;
    minuteChanged(minute: string): void;
    updateTime(): void;
    componentWillReceiveProps(newProps: ITimeInputProps): void;
    render(): JSX.Element;
}
export declare class TimeInputFormBinder extends FormBinderBase<ITimeInputProps, string, string> {
    static customValue(dataName: string): TimeInputFormBinder;
    handleValueChanged(props: ITimeInputProps, dataBinder: IDataBinder<any>, notifyChanged: () => void): void;
}
