"use strict";
var _ = require("underscore");
var PropertyPathResolver = (function () {
    function PropertyPathResolver() {
    }
    PropertyPathResolver.getValue = function (data, dataName) {
        var parts = dataName.split(".");
        return _.reduce(parts, function (result, p, index) {
            if (!result || !p) {
                throw new Error(dataName + " not found in data - failed on '" + p + "' (part: " + index + ")");
            }
            return result[p];
        }, data);
    };
    PropertyPathResolver.setValue = function (data, dataName, value) {
        var parts = dataName.split(".");
        var lastIndex = parts.length - 1;
        _.each(parts, function (p, index) {
            if (!data || !p) {
                throw new Error(dataName + " not found in data - failed on '" + p + "' (part: " + index + ")");
            }
            if (index === lastIndex) {
                data[p] = value;
                return;
            }
            data = data[p];
        });
    };
    return PropertyPathResolver;
}());
exports.PropertyPathResolver = PropertyPathResolver;
